<div id="top"></div>
<!--
*** Thanks for checking out the Best-README-Template. If you have a suggestion
*** that would make this better, please fork the repo and create a pull request
*** or simply open an issue with the tag "enhancement".
*** Don't forget to give the project a star!
*** Thanks again! Now go create something AMAZING! :D
-->



<!-- PROJECT SHIELDS -->
<!--
*** I'm using markdown "reference style" links for readability.
*** Reference links are enclosed in brackets [ ] instead of parentheses ( ).
*** See the bottom of this document for the declaration of the reference variables
*** for contributors-url, forks-url, etc. This is an optional, concise syntax you may use.
*** https://www.markdownguide.org/basic-syntax/#reference-style-links
-->
[![Contributors][contributors-shield]][contributors-url]
[![Forks][forks-shield]][forks-url]
[![Stargazers][stars-shield]][stars-url]
[![Issues][issues-shield]][issues-url]
[![MIT License][license-shield]][license-url]
[![LinkedIn][linkedin-shield]][linkedin-url]



<!-- PROJECT LOGO -->
<br />
<div align="center">
  <a href="https://github.com/TechnoVisionDev/TechnoBot">
    <img src="https://i.imgur.com/EXlIpl3.png" alt="Logo" width="80" height="80">
  </a>

  <h3 align="center">TechnoBot</h3>

  <p align="center">
    An advanced, multi-purpose bot for Discord
    <br />
    <a href="https://technobot.app"><strong>Explore this project »</strong></a>
    <br />
    <br />
    <a href="https://github.com/TechnoVisionDev/TechnoBot/wiki">Visit Wiki</a>
    ·
    <a href="https://github.com/TechnoVisionDev/TechnoBot/issues">Report Bug</a>
    ·
    <a href="https://github.com/TechnoVisionDev/TechnoBot/issues">Request Feature</a>
  </p>
</div>



<!-- TABLE OF CONTENTS -->
<details>
  <summary>Table of Contents</summary>
  <ol>
    <li>
      <a href="#about-the-project">About The Project</a>
      <ul>
        <li><a href="#built-with">Built With</a></li>
      </ul>
    </li>
    <li>
      <a href="#getting-started">Getting Started</a>
      <ul>
        <li><a href="#prerequisites">Prerequisites</a></li>
        <li><a href="#installation">Installation</a></li>
      </ul>
    </li>
    <li><a href="#contributing">Contributing</a></li>
    <li><a href="#license">License</a></li>
    <li><a href="#contact">Contact</a></li>
    <li><a href="#acknowledgments">Acknowledgments</a></li>
  </ol>
</details>



<!-- ABOUT THE PROJECT -->
## About The Project

TechnoBot is an advanced discord bot built to provide a wide array of features, including a leveling system, economy, starboard, suggestion board, moderation commands, fun commands, utility commands, auto roles, and so much more! It's purpose is to make your life easier and replace other bots as the main source of your guild's engagement! This project runs entirely on donations, so please consider supporting at https://www.patreon.com/TechnoVision

<p align="right">(<a href="#top">back to top</a>)</p>



### Built With

Below is a comprehensive list of the frameworks and libraries used to build the TechnoBot website.

* [Java Discord API](https://github.com/DV8FromTheWorld/JDA)
* [MongoDB Java Driver](https://mongodb.github.io/mongo-java-driver)
* [DotEnv](https://github.com/cdimascio/dotenv-java)
* [LavaPlayer](https://github.com/Walkyst/lavaplayer-fork)
* [Gson](https://github.com/google/gson)
* [OkHttp](https://github.com/square/okhttp)

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- GETTING STARTED -->
## Self Hosting

To get a local copy of TechnoBot up and running, follow these simple steps.

### Prerequisites

You must have [Java JDK 17](https://www.oracle.com/java/technologies/downloads/) installed on your machine.

### Installation

_Below are the necessary steps needed to run this project._

1. Clone the repo:
   ```sh
   git clone https://github.com/TechnoVisionDev/TechnoBot.git
   ```
2. Create a `.env` file in the root project folder and populate it with all the variables in `.env.example`.
3. You can now build and run the application using maven or the provided docker file.

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- CONTRIBUTING -->
## Contributing

Contributions are what make the open source community such an amazing place to learn, inspire, and create. Any contributions you make are **greatly appreciated**. You can also contribute monetarily at https://www.patreon.com/TechnoVision.

If you have a suggestion that would make this better, please fork the repo and create a pull request. You can also simply open an issue with the tag "enhancement".
Don't forget to give the project a star! Thanks again!

1. Fork the Project
2. Create your Feature Branch (`git checkout -b feature/AmazingFeature`)
3. Commit your Changes (`git commit -m 'Add some AmazingFeature'`)
4. Push to the Branch (`git push origin feature/AmazingFeature`)
5. Open a Pull Request

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- LICENSE -->
## License

TechnoBot is licensed under the terms of [Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International](https://github.com/ChristopherBThai/TechnoBot/blob/master/LICENSE) ("CC-BY-NC-SA-4.0"). Commercial use is not allowed under this license. This includes any kind of revenue made with or based upon the software, even donations.

The CC-BY-NC-SA-4.0 allows you to:
- [x] **Share** -- copy and redistribute the material in any medium or format
- [x] **Adapt** -- remix, transform, and build upon the material

Under the following terms:
- **Attribution** — You must give appropriate credit, provide a link to the license, and indicate if changes were made. You may do so in any reasonable manner, but not in any way that suggests the licensor endorses you or your use.
- **NonCommercial** — You may not use the material for commercial purposes. 
- **ShareAlike** — If you remix, transform, or build upon the material, you must distribute your contributions under the same license as the original.

More information can be found [here](https://creativecommons.org/licenses/by-nc-sa/4.0/).

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- CONTACT -->
## Contact

Thomas Peters - [@tomm__peters](https://twitter.com/tomm__peters) - tapeters@usc.edu

Project Link: [https://github.com/TechnoVisionDev/TechnoBot](https://github.com/TechnoVisionDev/TechnoBot)

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- ACKNOWLEDGMENTS -->
## Acknowledgments

Below are some resources that have been instrumental in making this project a reality!

* [JDA Wiki](https://jda.wiki/introduction/jda/)
* [JDA Support Discord](https://discord.gg/0hMr4ce0tIl3SLv5)
* [Choose an Open Source License](https://choosealicense.com)
* [GitHub Emoji Cheat Sheet](https://www.webpagefx.com/tools/emoji-cheat-sheet)
* [GitHub Pages](https://pages.github.com)

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- MARKDOWN LINKS & IMAGES -->
<!-- https://www.markdownguide.org/basic-syntax/#reference-style-links -->
[contributors-shield]: https://img.shields.io/github/contributors/TechnoVisionDev/TechnoBot.svg?style=for-the-badge
[contributors-url]: https://github.com/TechnoVisionDev/TechnoBot/graphs/contributors
[forks-shield]: https://img.shields.io/github/forks/TechnoVisionDev/TechnoBot.svg?style=for-the-badge
[forks-url]: https://github.com/TechnoVisionDev/TechnoBot/network/members
[stars-shield]: https://img.shields.io/github/stars/TechnoVisionDev/TechnoBot.svg?style=for-the-badge
[stars-url]: https://github.com/TechnoVisionDev/TechnoBot/stargazers
[issues-shield]: https://img.shields.io/github/issues/TechnoVisionDev/TechnoBot.svg?style=for-the-badge
[issues-url]: https://github.com/TechnoVisionDev/TechnoBot/issues
[license-shield]: https://img.shields.io/badge/LICENSE-CC%20BY--NC--SA%204.0-orange.svg?style=for-the-badge
[license-url]: https://github.com/TechnoVisionDev/TechnoBot/blob/master/LICENSE
[linkedin-shield]: https://img.shields.io/badge/-LinkedIn-black.svg?style=for-the-badge&logo=linkedin&colorB=555
[linkedin-url]: https://linkedin.com/in/thomaspeters
[product-screenshot]: src/main/webapp/assets/github/screenshot.png
